# -*- coding: utf-8 -*-
# Generated by Django 1.10.5 on 2017-01-11 22:11
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='MapItem',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('geo_type', models.CharField(max_length=100)),
                ('slug', models.SlugField()),
                ('geocode', models.CharField(max_length=255)),
                ('place_id', models.CharField(max_length=255)),
                ('name', models.CharField(max_length=255)),
                ('short_name', models.CharField(blank=True, max_length=255)),
                ('response_json', models.TextField(blank=True)),
                ('use_viewport', models.BooleanField(default=True)),
                ('url', models.CharField(blank=True, max_length=255)),
                ('custom_zoom', models.PositiveSmallIntegerField(blank=True, choices=[(1, 1), (2, 2), (3, 3), (4, 4), (5, 5), (6, 6), (7, 7), (8, 8), (9, 9), (10, 10), (11, 11), (12, 12), (13, 13), (14, 14), (15, 15), (16, 16), (17, 17), (18, 18), (19, 19), (20, 20), (21, 21)], null=True)),
            ],
        ),
        migrations.CreateModel(
            name='PoliticalPlace',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('country', models.CharField(blank=True, max_length=255)),
                ('administrative_area_level_1', models.CharField(blank=True, max_length=255)),
                ('administrative_area_level_2', models.CharField(blank=True, max_length=255)),
                ('administrative_area_level_3', models.CharField(blank=True, max_length=255)),
                ('administrative_area_level_4', models.CharField(blank=True, max_length=255)),
                ('administrative_area_level_5', models.CharField(blank=True, max_length=255)),
                ('locality', models.CharField(blank=True, max_length=255)),
                ('sublocality', models.CharField(blank=True, max_length=255)),
                ('neighborhood', models.CharField(blank=True, max_length=255)),
                ('premise', models.CharField(blank=True, max_length=255)),
                ('subpremise', models.CharField(blank=True, max_length=255)),
                ('postal_code', models.CharField(blank=True, max_length=255)),
                ('natural_feature', models.CharField(blank=True, max_length=255)),
                ('airport', models.CharField(blank=True, max_length=255)),
                ('park', models.CharField(blank=True, max_length=255)),
                ('street_address', models.CharField(blank=True, max_length=255)),
                ('street_number', models.CharField(blank=True, max_length=255)),
                ('route', models.CharField(blank=True, max_length=255)),
                ('intersection', models.CharField(blank=True, max_length=255)),
                ('address', models.CharField(max_length=255)),
                ('geocode', models.CharField(blank=True, max_length=255)),
                ('place_id', models.CharField(max_length=255, unique=True)),
                ('administrative_area_level_1_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_aal1_set', to='politicalplaces.MapItem')),
                ('administrative_area_level_2_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_aal2_set', to='politicalplaces.MapItem')),
                ('administrative_area_level_3_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_aal3_set', to='politicalplaces.MapItem')),
                ('administrative_area_level_4_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_aal4_set', to='politicalplaces.MapItem')),
                ('administrative_area_level_5_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_aal5_set', to='politicalplaces.MapItem')),
                ('continent_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_continent_set', to='politicalplaces.MapItem')),
                ('country_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_country_set', to='politicalplaces.MapItem')),
                ('locality_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_locality_set', to='politicalplaces.MapItem')),
                ('neighborhood_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_neighborhood_set', to='politicalplaces.MapItem')),
                ('postal_code_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_postal_code_set', to='politicalplaces.MapItem')),
                ('sublocality_item', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='gmapsplace_sublocality_set', to='politicalplaces.MapItem')),
            ],
        ),
    ]
